VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EmployeeCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Employees As Collection
' Add an Employee object to the collection.
Public Sub Add(ByVal emp As Employee, Optional ByVal key As Variant)
    If IsMissing(key) Then
        m_Employees.Add emp
    Else
        m_Employees.Add emp, key
    End If
End Sub
' Return the number of items in the collection.
Public Function Count() As Long
    Count = m_Employees.Count
End Function
' Return an Employee object.
'
' To make this the collection's default method:
' 1. Select Tools\Procedure Attributes
' 2. Select this function in the Name dropdown.
' 3. Click Advanced.
' 4. Select (Default) in the Procedure ID dropdown.
Public Function Item(ByVal Index As Variant) As Employee
Attribute Item.VB_UserMemId = 0
    Set Item = m_Employees(Index)
End Function


' Remove an Employee object from the collection.
Public Sub Remove(ByVal Index As Variant)
    m_Employees.Remove Index
End Sub
' To allow For Each enumeration, write this
' function and then:
' 1. Select Tools\Procedure Attributes.
' 2. Select this function in the Name dropdown.
' 3. Click Advanced.
' 4. Enter -4 as the Procedure ID.
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
    Set NewEnum = m_Employees.[_NewEnum]
End Function
Private Sub Class_Initialize()
    Set m_Employees = New Collection
End Sub


