VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Employees"
   ClientHeight    =   3855
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   ScaleHeight     =   3855
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtId 
      Height          =   285
      Left            =   3480
      TabIndex        =   3
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton cmdGetByName 
      Caption         =   "Get by Name"
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   3480
      Width           =   1695
   End
   Begin VB.CommandButton cmdGetByIndex 
      Caption         =   "Get by Index"
      Height          =   375
      Left            =   2880
      TabIndex        =   8
      Top             =   3000
      Width           =   1695
   End
   Begin VB.CommandButton cmdRemoveByName 
      Caption         =   "Remove by Name"
      Height          =   375
      Left            =   2880
      TabIndex        =   7
      Top             =   2520
      Width           =   1695
   End
   Begin VB.TextBox txtIndex 
      Height          =   285
      Left            =   3480
      TabIndex        =   4
      Top             =   1200
      Width           =   1455
   End
   Begin VB.CommandButton cmdRemoveByIndex 
      Caption         =   "Remove by Index"
      Height          =   375
      Left            =   2880
      TabIndex        =   6
      Top             =   2040
      Width           =   1695
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   2880
      TabIndex        =   5
      Top             =   1560
      Width           =   1695
   End
   Begin VB.TextBox txtLastName 
      Height          =   285
      Left            =   3480
      TabIndex        =   2
      Top             =   360
      Width           =   1455
   End
   Begin VB.TextBox txtFirstName 
      Height          =   285
      Left            =   3480
      TabIndex        =   1
      Top             =   0
      Width           =   1455
   End
   Begin VB.TextBox txtEmployees 
      Height          =   3855
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "ID"
      Height          =   255
      Index           =   3
      Left            =   2520
      TabIndex        =   13
      Top             =   720
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Index"
      Height          =   255
      Index           =   2
      Left            =   2520
      TabIndex        =   12
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Last Name"
      Height          =   255
      Index           =   1
      Left            =   2520
      TabIndex        =   11
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "First Name"
      Height          =   255
      Index           =   0
      Left            =   2520
      TabIndex        =   10
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Employees As EmployeeCollection

Private Sub ListEmployees()
Dim emp As Employee
Dim txt As String

    For Each emp In m_Employees
        txt = txt & emp.LastName & ", " & _
            emp.FirstName & vbCrLf
    Next emp
    txtEmployees.Text = txt
End Sub

Private Sub LoadData()
Dim emp As Employee

    Set m_Employees = New EmployeeCollection

    Set emp = New Employee
    With emp
        .FirstName = "Andrew"
        .LastName = "Archer"
        .EmployeeId = 723612
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName

    Set emp = New Employee
    With emp
        .FirstName = "Bianca"
        .LastName = "Baker"
        .EmployeeId = 287346
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName

    Set emp = New Employee
    With emp
        .FirstName = "Charles"
        .LastName = "Candleson"
        .EmployeeId = 623764
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName

    Set emp = New Employee
    With emp
        .FirstName = "Deborah"
        .LastName = "Danvers"
        .EmployeeId = 2187645
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName

    Set emp = New Employee
    With emp
        .FirstName = "Edward"
        .LastName = "Eagle"
        .EmployeeId = 493870
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName

    Set emp = New Employee
    With emp
        .FirstName = "Francine"
        .LastName = "Frink"
        .EmployeeId = 2186764
    End With
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName
End Sub
' Add a new employee using LastName,FirstName
' as the key.
Private Sub cmdAdd_Click()
Dim emp As New Employee

    emp.FirstName = txtFirstName.Text
    emp.LastName = txtLastName.Text
    emp.EmployeeId = txtId.Text
    On Error GoTo AddError
    m_Employees.Add emp, emp.LastName & "," & emp.FirstName
    On Error GoTo 0

    txtFirstName.Text = ""
    txtLastName.Text = ""
    txtId.Text = ""
    ListEmployees
    Exit Sub

AddError:
    MsgBox Err.Description
    Exit Sub
End Sub

Private Sub cmdGetByIndex_Click()
Dim emp As Employee

    On Error GoTo GetByIndexError
    Set emp = m_Employees(CLng(txtIndex.Text))
    On Error GoTo 0

    txtFirstName.Text = emp.FirstName
    txtLastName.Text = emp.LastName
    txtId.Text = emp.EmployeeId
    Exit Sub

GetByIndexError:
    MsgBox Err.Description
    Exit Sub
End Sub

Private Sub cmdGetByName_Click()
Dim emp As Employee

    On Error GoTo GetByNameError
    Set emp = m_Employees(txtLastName.Text & "," & txtFirstName.Text)
    On Error GoTo 0

    txtFirstName.Text = emp.FirstName
    txtLastName.Text = emp.LastName
    txtId.Text = emp.EmployeeId
    Exit Sub

GetByNameError:
    MsgBox Err.Description
    Exit Sub
End Sub
Private Sub cmdRemoveByIndex_Click()
    On Error GoTo RemoveByIndexError
    m_Employees.Remove CLng(txtIndex.Text)
    On Error GoTo 0

    ListEmployees
    Exit Sub

RemoveByIndexError:
    MsgBox Err.Description
    Exit Sub
End Sub

Private Sub cmdRemoveByName_Click()
    On Error GoTo RemoveByIndexError
    m_Employees.Remove txtLastName.Text & "," & txtFirstName.Text
    On Error GoTo 0

    ListEmployees
    Exit Sub

RemoveByIndexError:
    MsgBox Err.Description
    Exit Sub
End Sub
Private Sub Form_Load()
    LoadData
    ListEmployees
End Sub
